#include <iostream>   //std::cerr
#include <fstream>    //std::ifstream, std::ofstream
#include <string>     //std::string, string::npos
#include <map>        //std::map
#include <cstring>    //strstr()
using namespace std;

int main(int argc, char* argv[])
{
	if(argc < 3)
		cerr << "Error: not enough arguments. Please enter the names of input and output files.\n\nHelp:\n[RU] Данная программа осуществляет перевод с английского языка на русский и наоборот. Для файлов с расширением .insml языком по умолчанию выбран русский. Если расширение выходного файла не .insml, то открывается входной файл и проверяется как указан заголовок ИНС: если по-русски, то переводим на английский, если по-английски, то переводим на русский. Это сделано с целью упростить работу людей, которые берут куски чужих нейронных сетей, т.к. основные теги все равно пишутся на родном языке.\n[EN] This program implements English-Russian translation and vice-versa. Russian is the default language for .insml files. If the filename extention of the output file is not .insml, the input file opens and the ANN title is being checked: if it is in Russian then it's translated into English, if it's in English, then it's translated into Russian. It is necessary for simplification of the work of people who take parts of unfamiliar neural networks as main tags are written in mother tongue." << endl;

	//загрузка словаря
	ifstream fin("source/dictionary.txt", ios::binary);
	map<string, string> dict;
	if(fin.is_open())
	{
		string str1, str2;
		while(fin >> str1 >> str2)
			dict[str1] = str2;
		fin.clear();
		fin.close();
	}
	else
		cerr << "Error: unable to open dictionary file." << endl;

	//загрузка текста для перевода
	if(strstr(argv[2], ".insml") != NULL)
	{
		fin.open(argv[1], ios::binary);
		ofstream fout(argv[2], ios::binary);

		if(fout == NULL)
			cerr << "Error: unable to open output file." << endl;

		if(fin.is_open())
		{
			string text;
			for(char c; fin.get(c); )
				if('<' == c)
				{
					fin.get(c);
					if(('/') == c)
					{
						for(; fin.get(c) && '>' != c; text += c)
							;
						for(auto it = dict.begin(); it != dict.end(); ++it)
							if(it->first == text)
								fout << "</" << it->second << ">";
						text.clear();
					}
					else
					{
						text += c;
						for(; fin.get(c) && '>' != c; text += c)
							;
						for(auto it = dict.begin(); it != dict.end(); ++it)
							if(it->first == text)
								fout << "<" << it->second << ">";
						text.clear();
					}
				}
				else
					fout << c;
		}
		else
			cerr << "Error: unable to open input file." << endl;
	}
	else
	{
		fin.open(argv[1], ios::binary);
		if(fin)
		{
			string str;
			for(char c; fin.get(c); )
				if(('<') == c)
				{
					for(; fin.get(c) && '>' != c; str+= c)
						;
					if(str.find("net") != string::npos)
					{
						ifstream fin1(argv[1], ios::binary);
						ofstream fout(argv[2], ios::binary);
						if(fout == NULL)
							cerr << "Error: unable to open output file." << endl;
						if(fin1.is_open())
						{
							string text;
							for(char c; fin1.get(c); )
								if('<' == c)
								{
									fin1.get(c);
									if(('/') == c)
									{
										for(; fin1.get(c) && '>' != c; text += c)
											;
										for(auto it = dict.begin(); it != dict.end(); ++it)
											if(it->first == text)
												fout << "</" << it->second << ">";
										text.clear();
									}
									else
									{
										text += c;
										for(; fin1.get(c) && '>' != c; text += c)
											;
										for(auto it = dict.begin(); it != dict.end(); ++it)
											if(it->first == text)
												fout << "<" << it->second << ">";
										text.clear();
									}
								}
								else
									fout << c;
						}
						else
							cerr << "Error: unable to open input file." << endl;
					}
					else if(str.find("сеть") != string::npos)
					{
						ifstream fin1(argv[1], ios::binary);
						ofstream fout(argv[2], ios::binary);
						if(fout == NULL)
							cerr << "Error: unable to open output file." << endl;
						if(fin1.is_open())
						{
							string text;
							for(char c; fin1.get(c); )
								if('<' == c)
								{
									fin1.get(c);
									if(('/') == c)
									{
										for(; fin1.get(c) && '>' != c; text += c)
											;
										for(auto it = dict.begin(); it != dict.end(); ++it)
											if(it->second == text)
												fout << "</" << it->first << ">";
										text.clear();
									}
									else
									{
										text += c;
										for(; fin1.get(c) && '>' != c; text += c)
											;
										for(auto it = dict.begin(); it != dict.end(); ++it)
											if(it->second == text)
												fout << "<" << it->first << ">";
										text.clear();
									}
								}
								else
									fout << c;
						}
						else
							cerr << "Error: unable to open input file." << endl;
					}
				}
		}
		fin.close();
	}

	return 0;
}
